// Generated by dts-bundle v0.7.3
// Dependencies for this module:
//   ../jsonc-eslint-parser
//   ../json-schema
//   ../eslint
//   ../estree

declare module 'eslint-plugin-jsonc' {
    import type { RuleModule } from "eslint-plugin-jsonc/types";
    import * as meta from "eslint-plugin-jsonc/meta";
    import { parseForESLint, parseJSON, traverseNodes, AST, getStaticJSONValue } from "jsonc-eslint-parser";
    const configs: {
        base: {
            plugins: string[];
            overrides: {
                files: string[];
                parser: string;
                rules: {
                    strict: string;
                    "no-unused-expressions": string;
                    "no-unused-vars": string;
                };
            }[];
        };
        "auto-config": {
            extends: string[];
            rules: {
                "jsonc/auto": string;
            };
        };
        "recommended-with-json": {
            extends: string[];
            rules: {
                "jsonc/comma-dangle": string;
                "jsonc/no-bigint-literals": string;
                "jsonc/no-binary-expression": string;
                "jsonc/no-binary-numeric-literals": string;
                "jsonc/no-comments": string;
                "jsonc/no-dupe-keys": string;
                "jsonc/no-escape-sequence-in-identifier": string;
                "jsonc/no-floating-decimal": string;
                "jsonc/no-hexadecimal-numeric-literals": string;
                "jsonc/no-infinity": string;
                "jsonc/no-multi-str": string;
                "jsonc/no-nan": string;
                "jsonc/no-number-props": string;
                "jsonc/no-numeric-separators": string;
                "jsonc/no-octal-numeric-literals": string;
                "jsonc/no-octal": string;
                "jsonc/no-parenthesized": string;
                "jsonc/no-plus-sign": string;
                "jsonc/no-regexp-literals": string;
                "jsonc/no-sparse-arrays": string;
                "jsonc/no-template-literals": string;
                "jsonc/no-undefined-value": string;
                "jsonc/no-unicode-codepoint-escapes": string;
                "jsonc/no-useless-escape": string;
                "jsonc/quote-props": string;
                "jsonc/quotes": string;
                "jsonc/space-unary-ops": string;
                "jsonc/valid-json-number": string;
                "jsonc/vue-custom-block/no-parsing-error": string;
            };
        };
        "recommended-with-jsonc": {
            extends: string[];
            rules: {
                "jsonc/no-bigint-literals": string;
                "jsonc/no-binary-expression": string;
                "jsonc/no-binary-numeric-literals": string;
                "jsonc/no-dupe-keys": string;
                "jsonc/no-escape-sequence-in-identifier": string;
                "jsonc/no-floating-decimal": string;
                "jsonc/no-hexadecimal-numeric-literals": string;
                "jsonc/no-infinity": string;
                "jsonc/no-multi-str": string;
                "jsonc/no-nan": string;
                "jsonc/no-number-props": string;
                "jsonc/no-numeric-separators": string;
                "jsonc/no-octal-numeric-literals": string;
                "jsonc/no-octal": string;
                "jsonc/no-parenthesized": string;
                "jsonc/no-plus-sign": string;
                "jsonc/no-regexp-literals": string;
                "jsonc/no-sparse-arrays": string;
                "jsonc/no-template-literals": string;
                "jsonc/no-undefined-value": string;
                "jsonc/no-unicode-codepoint-escapes": string;
                "jsonc/no-useless-escape": string;
                "jsonc/quote-props": string;
                "jsonc/quotes": string;
                "jsonc/space-unary-ops": string;
                "jsonc/valid-json-number": string;
                "jsonc/vue-custom-block/no-parsing-error": string;
            };
        };
        "recommended-with-json5": {
            extends: string[];
            rules: {
                "jsonc/no-bigint-literals": string;
                "jsonc/no-binary-expression": string;
                "jsonc/no-binary-numeric-literals": string;
                "jsonc/no-dupe-keys": string;
                "jsonc/no-escape-sequence-in-identifier": string;
                "jsonc/no-number-props": string;
                "jsonc/no-numeric-separators": string;
                "jsonc/no-octal-numeric-literals": string;
                "jsonc/no-octal": string;
                "jsonc/no-parenthesized": string;
                "jsonc/no-regexp-literals": string;
                "jsonc/no-sparse-arrays": string;
                "jsonc/no-template-literals": string;
                "jsonc/no-undefined-value": string;
                "jsonc/no-unicode-codepoint-escapes": string;
                "jsonc/no-useless-escape": string;
                "jsonc/space-unary-ops": string;
                "jsonc/vue-custom-block/no-parsing-error": string;
            };
        };
        prettier: {
            extends: string[];
            rules: {
                "jsonc/array-bracket-newline": string;
                "jsonc/array-bracket-spacing": string;
                "jsonc/array-element-newline": string;
                "jsonc/comma-dangle": string;
                "jsonc/comma-style": string;
                "jsonc/indent": string;
                "jsonc/key-spacing": string;
                "jsonc/no-floating-decimal": string;
                "jsonc/object-curly-newline": string;
                "jsonc/object-curly-spacing": string;
                "jsonc/object-property-newline": string;
                "jsonc/quote-props": string;
                "jsonc/quotes": string;
                "jsonc/space-unary-ops": string;
            };
        };
        all: {
            extends: string[];
            rules: {
                [x: string]: string;
            };
        };
        "flat/base": {
            plugins: string[];
            overrides: {
                files: string[];
                parser: string;
                rules: {
                    strict: string;
                    "no-unused-expressions": string;
                    "no-unused-vars": string;
                };
            }[];
        };
        "flat/recommended-with-json": ({
            files: string[];
            plugins: {
                readonly jsonc: import("eslint").ESLint.Plugin;
            };
            languageOptions: {
                parser: typeof import("jsonc-eslint-parser");
            };
            rules: {
                strict: string;
                "no-unused-expressions": string;
                "no-unused-vars": string;
            };
        } | {
            rules: {
                "jsonc/comma-dangle": string;
                "jsonc/no-bigint-literals": string;
                "jsonc/no-binary-expression": string;
                "jsonc/no-binary-numeric-literals": string;
                "jsonc/no-comments": string;
                "jsonc/no-dupe-keys": string;
                "jsonc/no-escape-sequence-in-identifier": string;
                "jsonc/no-floating-decimal": string;
                "jsonc/no-hexadecimal-numeric-literals": string;
                "jsonc/no-infinity": string;
                "jsonc/no-multi-str": string;
                "jsonc/no-nan": string;
                "jsonc/no-number-props": string;
                "jsonc/no-numeric-separators": string;
                "jsonc/no-octal-numeric-literals": string;
                "jsonc/no-octal": string;
                "jsonc/no-parenthesized": string;
                "jsonc/no-plus-sign": string;
                "jsonc/no-regexp-literals": string;
                "jsonc/no-sparse-arrays": string;
                "jsonc/no-template-literals": string;
                "jsonc/no-undefined-value": string;
                "jsonc/no-unicode-codepoint-escapes": string;
                "jsonc/no-useless-escape": string;
                "jsonc/quote-props": string;
                "jsonc/quotes": string;
                "jsonc/space-unary-ops": string;
                "jsonc/valid-json-number": string;
                "jsonc/vue-custom-block/no-parsing-error": string;
            };
        })[];
        "flat/recommended-with-jsonc": ({
            files: string[];
            plugins: {
                readonly jsonc: import("eslint").ESLint.Plugin;
            };
            languageOptions: {
                parser: typeof import("jsonc-eslint-parser");
            };
            rules: {
                strict: string;
                "no-unused-expressions": string;
                "no-unused-vars": string;
            };
        } | {
            rules: {
                "jsonc/no-bigint-literals": string;
                "jsonc/no-binary-expression": string;
                "jsonc/no-binary-numeric-literals": string;
                "jsonc/no-dupe-keys": string;
                "jsonc/no-escape-sequence-in-identifier": string;
                "jsonc/no-floating-decimal": string;
                "jsonc/no-hexadecimal-numeric-literals": string;
                "jsonc/no-infinity": string;
                "jsonc/no-multi-str": string;
                "jsonc/no-nan": string;
                "jsonc/no-number-props": string;
                "jsonc/no-numeric-separators": string;
                "jsonc/no-octal-numeric-literals": string;
                "jsonc/no-octal": string;
                "jsonc/no-parenthesized": string;
                "jsonc/no-plus-sign": string;
                "jsonc/no-regexp-literals": string;
                "jsonc/no-sparse-arrays": string;
                "jsonc/no-template-literals": string;
                "jsonc/no-undefined-value": string;
                "jsonc/no-unicode-codepoint-escapes": string;
                "jsonc/no-useless-escape": string;
                "jsonc/quote-props": string;
                "jsonc/quotes": string;
                "jsonc/space-unary-ops": string;
                "jsonc/valid-json-number": string;
                "jsonc/vue-custom-block/no-parsing-error": string;
            };
        })[];
        "flat/recommended-with-json5": ({
            files: string[];
            plugins: {
                readonly jsonc: import("eslint").ESLint.Plugin;
            };
            languageOptions: {
                parser: typeof import("jsonc-eslint-parser");
            };
            rules: {
                strict: string;
                "no-unused-expressions": string;
                "no-unused-vars": string;
            };
        } | {
            rules: {
                "jsonc/no-bigint-literals": string;
                "jsonc/no-binary-expression": string;
                "jsonc/no-binary-numeric-literals": string;
                "jsonc/no-dupe-keys": string;
                "jsonc/no-escape-sequence-in-identifier": string;
                "jsonc/no-number-props": string;
                "jsonc/no-numeric-separators": string;
                "jsonc/no-octal-numeric-literals": string;
                "jsonc/no-octal": string;
                "jsonc/no-parenthesized": string;
                "jsonc/no-regexp-literals": string;
                "jsonc/no-sparse-arrays": string;
                "jsonc/no-template-literals": string;
                "jsonc/no-undefined-value": string;
                "jsonc/no-unicode-codepoint-escapes": string;
                "jsonc/no-useless-escape": string;
                "jsonc/space-unary-ops": string;
                "jsonc/vue-custom-block/no-parsing-error": string;
            };
        })[];
        "flat/prettier": ({
            files: string[];
            plugins: {
                readonly jsonc: import("eslint").ESLint.Plugin;
            };
            languageOptions: {
                parser: typeof import("jsonc-eslint-parser");
            };
            rules: {
                strict: string;
                "no-unused-expressions": string;
                "no-unused-vars": string;
            };
        } | {
            rules: {
                "jsonc/array-bracket-newline": string;
                "jsonc/array-bracket-spacing": string;
                "jsonc/array-element-newline": string;
                "jsonc/comma-dangle": string;
                "jsonc/comma-style": string;
                "jsonc/indent": string;
                "jsonc/key-spacing": string;
                "jsonc/no-floating-decimal": string;
                "jsonc/object-curly-newline": string;
                "jsonc/object-curly-spacing": string;
                "jsonc/object-property-newline": string;
                "jsonc/quote-props": string;
                "jsonc/quotes": string;
                "jsonc/space-unary-ops": string;
            };
        })[];
        "flat/all": {
            extends: string[];
            rules: {
                [x: string]: string;
            };
        };
    };
    const rules: {
        [key: string]: RuleModule;
    };
    const _default: {
        meta: typeof meta;
        configs: {
            base: {
                plugins: string[];
                overrides: {
                    files: string[];
                    parser: string;
                    rules: {
                        strict: string;
                        "no-unused-expressions": string;
                        "no-unused-vars": string;
                    };
                }[];
            };
            "auto-config": {
                extends: string[];
                rules: {
                    "jsonc/auto": string;
                };
            };
            "recommended-with-json": {
                extends: string[];
                rules: {
                    "jsonc/comma-dangle": string;
                    "jsonc/no-bigint-literals": string;
                    "jsonc/no-binary-expression": string;
                    "jsonc/no-binary-numeric-literals": string;
                    "jsonc/no-comments": string;
                    "jsonc/no-dupe-keys": string;
                    "jsonc/no-escape-sequence-in-identifier": string;
                    "jsonc/no-floating-decimal": string;
                    "jsonc/no-hexadecimal-numeric-literals": string;
                    "jsonc/no-infinity": string;
                    "jsonc/no-multi-str": string;
                    "jsonc/no-nan": string;
                    "jsonc/no-number-props": string;
                    "jsonc/no-numeric-separators": string;
                    "jsonc/no-octal-numeric-literals": string;
                    "jsonc/no-octal": string;
                    "jsonc/no-parenthesized": string;
                    "jsonc/no-plus-sign": string;
                    "jsonc/no-regexp-literals": string;
                    "jsonc/no-sparse-arrays": string;
                    "jsonc/no-template-literals": string;
                    "jsonc/no-undefined-value": string;
                    "jsonc/no-unicode-codepoint-escapes": string;
                    "jsonc/no-useless-escape": string;
                    "jsonc/quote-props": string;
                    "jsonc/quotes": string;
                    "jsonc/space-unary-ops": string;
                    "jsonc/valid-json-number": string;
                    "jsonc/vue-custom-block/no-parsing-error": string;
                };
            };
            "recommended-with-jsonc": {
                extends: string[];
                rules: {
                    "jsonc/no-bigint-literals": string;
                    "jsonc/no-binary-expression": string;
                    "jsonc/no-binary-numeric-literals": string;
                    "jsonc/no-dupe-keys": string;
                    "jsonc/no-escape-sequence-in-identifier": string;
                    "jsonc/no-floating-decimal": string;
                    "jsonc/no-hexadecimal-numeric-literals": string;
                    "jsonc/no-infinity": string;
                    "jsonc/no-multi-str": string;
                    "jsonc/no-nan": string;
                    "jsonc/no-number-props": string;
                    "jsonc/no-numeric-separators": string;
                    "jsonc/no-octal-numeric-literals": string;
                    "jsonc/no-octal": string;
                    "jsonc/no-parenthesized": string;
                    "jsonc/no-plus-sign": string;
                    "jsonc/no-regexp-literals": string;
                    "jsonc/no-sparse-arrays": string;
                    "jsonc/no-template-literals": string;
                    "jsonc/no-undefined-value": string;
                    "jsonc/no-unicode-codepoint-escapes": string;
                    "jsonc/no-useless-escape": string;
                    "jsonc/quote-props": string;
                    "jsonc/quotes": string;
                    "jsonc/space-unary-ops": string;
                    "jsonc/valid-json-number": string;
                    "jsonc/vue-custom-block/no-parsing-error": string;
                };
            };
            "recommended-with-json5": {
                extends: string[];
                rules: {
                    "jsonc/no-bigint-literals": string;
                    "jsonc/no-binary-expression": string;
                    "jsonc/no-binary-numeric-literals": string;
                    "jsonc/no-dupe-keys": string;
                    "jsonc/no-escape-sequence-in-identifier": string;
                    "jsonc/no-number-props": string;
                    "jsonc/no-numeric-separators": string;
                    "jsonc/no-octal-numeric-literals": string;
                    "jsonc/no-octal": string;
                    "jsonc/no-parenthesized": string;
                    "jsonc/no-regexp-literals": string;
                    "jsonc/no-sparse-arrays": string;
                    "jsonc/no-template-literals": string;
                    "jsonc/no-undefined-value": string;
                    "jsonc/no-unicode-codepoint-escapes": string;
                    "jsonc/no-useless-escape": string;
                    "jsonc/space-unary-ops": string;
                    "jsonc/vue-custom-block/no-parsing-error": string;
                };
            };
            prettier: {
                extends: string[];
                rules: {
                    "jsonc/array-bracket-newline": string;
                    "jsonc/array-bracket-spacing": string;
                    "jsonc/array-element-newline": string;
                    "jsonc/comma-dangle": string;
                    "jsonc/comma-style": string;
                    "jsonc/indent": string;
                    "jsonc/key-spacing": string;
                    "jsonc/no-floating-decimal": string;
                    "jsonc/object-curly-newline": string;
                    "jsonc/object-curly-spacing": string;
                    "jsonc/object-property-newline": string;
                    "jsonc/quote-props": string;
                    "jsonc/quotes": string;
                    "jsonc/space-unary-ops": string;
                };
            };
            all: {
                extends: string[];
                rules: {
                    [x: string]: string;
                };
            };
            "flat/base": {
                plugins: string[];
                overrides: {
                    files: string[];
                    parser: string;
                    rules: {
                        strict: string;
                        "no-unused-expressions": string;
                        "no-unused-vars": string;
                    };
                }[];
            };
            "flat/recommended-with-json": ({
                files: string[];
                plugins: {
                    readonly jsonc: import("eslint").ESLint.Plugin;
                };
                languageOptions: {
                    parser: typeof import("jsonc-eslint-parser");
                };
                rules: {
                    strict: string;
                    "no-unused-expressions": string;
                    "no-unused-vars": string;
                };
            } | {
                rules: {
                    "jsonc/comma-dangle": string;
                    "jsonc/no-bigint-literals": string;
                    "jsonc/no-binary-expression": string;
                    "jsonc/no-binary-numeric-literals": string;
                    "jsonc/no-comments": string;
                    "jsonc/no-dupe-keys": string;
                    "jsonc/no-escape-sequence-in-identifier": string;
                    "jsonc/no-floating-decimal": string;
                    "jsonc/no-hexadecimal-numeric-literals": string;
                    "jsonc/no-infinity": string;
                    "jsonc/no-multi-str": string;
                    "jsonc/no-nan": string;
                    "jsonc/no-number-props": string;
                    "jsonc/no-numeric-separators": string;
                    "jsonc/no-octal-numeric-literals": string;
                    "jsonc/no-octal": string;
                    "jsonc/no-parenthesized": string;
                    "jsonc/no-plus-sign": string;
                    "jsonc/no-regexp-literals": string;
                    "jsonc/no-sparse-arrays": string;
                    "jsonc/no-template-literals": string;
                    "jsonc/no-undefined-value": string;
                    "jsonc/no-unicode-codepoint-escapes": string;
                    "jsonc/no-useless-escape": string;
                    "jsonc/quote-props": string;
                    "jsonc/quotes": string;
                    "jsonc/space-unary-ops": string;
                    "jsonc/valid-json-number": string;
                    "jsonc/vue-custom-block/no-parsing-error": string;
                };
            })[];
            "flat/recommended-with-jsonc": ({
                files: string[];
                plugins: {
                    readonly jsonc: import("eslint").ESLint.Plugin;
                };
                languageOptions: {
                    parser: typeof import("jsonc-eslint-parser");
                };
                rules: {
                    strict: string;
                    "no-unused-expressions": string;
                    "no-unused-vars": string;
                };
            } | {
                rules: {
                    "jsonc/no-bigint-literals": string;
                    "jsonc/no-binary-expression": string;
                    "jsonc/no-binary-numeric-literals": string;
                    "jsonc/no-dupe-keys": string;
                    "jsonc/no-escape-sequence-in-identifier": string;
                    "jsonc/no-floating-decimal": string;
                    "jsonc/no-hexadecimal-numeric-literals": string;
                    "jsonc/no-infinity": string;
                    "jsonc/no-multi-str": string;
                    "jsonc/no-nan": string;
                    "jsonc/no-number-props": string;
                    "jsonc/no-numeric-separators": string;
                    "jsonc/no-octal-numeric-literals": string;
                    "jsonc/no-octal": string;
                    "jsonc/no-parenthesized": string;
                    "jsonc/no-plus-sign": string;
                    "jsonc/no-regexp-literals": string;
                    "jsonc/no-sparse-arrays": string;
                    "jsonc/no-template-literals": string;
                    "jsonc/no-undefined-value": string;
                    "jsonc/no-unicode-codepoint-escapes": string;
                    "jsonc/no-useless-escape": string;
                    "jsonc/quote-props": string;
                    "jsonc/quotes": string;
                    "jsonc/space-unary-ops": string;
                    "jsonc/valid-json-number": string;
                    "jsonc/vue-custom-block/no-parsing-error": string;
                };
            })[];
            "flat/recommended-with-json5": ({
                files: string[];
                plugins: {
                    readonly jsonc: import("eslint").ESLint.Plugin;
                };
                languageOptions: {
                    parser: typeof import("jsonc-eslint-parser");
                };
                rules: {
                    strict: string;
                    "no-unused-expressions": string;
                    "no-unused-vars": string;
                };
            } | {
                rules: {
                    "jsonc/no-bigint-literals": string;
                    "jsonc/no-binary-expression": string;
                    "jsonc/no-binary-numeric-literals": string;
                    "jsonc/no-dupe-keys": string;
                    "jsonc/no-escape-sequence-in-identifier": string;
                    "jsonc/no-number-props": string;
                    "jsonc/no-numeric-separators": string;
                    "jsonc/no-octal-numeric-literals": string;
                    "jsonc/no-octal": string;
                    "jsonc/no-parenthesized": string;
                    "jsonc/no-regexp-literals": string;
                    "jsonc/no-sparse-arrays": string;
                    "jsonc/no-template-literals": string;
                    "jsonc/no-undefined-value": string;
                    "jsonc/no-unicode-codepoint-escapes": string;
                    "jsonc/no-useless-escape": string;
                    "jsonc/space-unary-ops": string;
                    "jsonc/vue-custom-block/no-parsing-error": string;
                };
            })[];
            "flat/prettier": ({
                files: string[];
                plugins: {
                    readonly jsonc: import("eslint").ESLint.Plugin;
                };
                languageOptions: {
                    parser: typeof import("jsonc-eslint-parser");
                };
                rules: {
                    strict: string;
                    "no-unused-expressions": string;
                    "no-unused-vars": string;
                };
            } | {
                rules: {
                    "jsonc/array-bracket-newline": string;
                    "jsonc/array-bracket-spacing": string;
                    "jsonc/array-element-newline": string;
                    "jsonc/comma-dangle": string;
                    "jsonc/comma-style": string;
                    "jsonc/indent": string;
                    "jsonc/key-spacing": string;
                    "jsonc/no-floating-decimal": string;
                    "jsonc/object-curly-newline": string;
                    "jsonc/object-curly-spacing": string;
                    "jsonc/object-property-newline": string;
                    "jsonc/quote-props": string;
                    "jsonc/quotes": string;
                    "jsonc/space-unary-ops": string;
                };
            })[];
            "flat/all": {
                extends: string[];
                rules: {
                    [x: string]: string;
                };
            };
        };
        rules: {
            [key: string]: RuleModule;
        };
        parseForESLint: typeof parseForESLint;
        parseJSON: typeof parseJSON;
        traverseNodes: typeof traverseNodes;
        getStaticJSONValue: typeof getStaticJSONValue;
    };
    export default _default;
    export { meta, configs, rules, parseForESLint, parseJSON, traverseNodes, getStaticJSONValue, AST, };
}

declare module 'eslint-plugin-jsonc/types' {
    import type { JSONSchema4 } from "json-schema";
    import type { Rule } from "eslint";
    import type { RuleListener } from "jsonc-eslint-parser";
    import type { AST as ESLintAST } from "eslint";
    import type * as ESTree from "estree";
    export type Token = ESLintAST.Token;
    export type Comment = ESTree.Comment;
    export { RuleListener };
    export interface RuleModule {
        meta: RuleMetaData;
        jsoncDefineRule: PartialRuleModule;
        create(context: Rule.RuleContext): RuleListener;
    }
    export interface RuleMetaData {
        docs: {
            description: string;
            recommended: ("json" | "jsonc" | "json5")[] | null;
            url: string;
            ruleId: string;
            ruleName: string;
            default?: "error" | "warn";
            extensionRule: boolean | string | {
                plugin: string;
                url: string;
            };
            layout: boolean;
        };
        messages: {
            [messageId: string]: string;
        };
        fixable?: "code" | "whitespace";
        hasSuggestions?: boolean;
        schema: JSONSchema4 | JSONSchema4[];
        deprecated?: boolean;
        replacedBy?: [];
        type: "problem" | "suggestion" | "layout";
    }
    export interface PartialRuleModule {
        meta: PartialRuleMetaData;
        create(context: Rule.RuleContext, params: {
            customBlock: boolean;
        }): RuleListener;
    }
    export interface PartialRuleMetaData {
        docs: {
            description: string;
            recommended: ("json" | "jsonc" | "json5")[] | null;
            default?: "error" | "warn";
            extensionRule: boolean | string | {
                plugin: string;
                url: string;
            };
            layout: boolean;
        };
        messages: {
            [messageId: string]: string;
        };
        fixable?: "code" | "whitespace";
        hasSuggestions?: boolean;
        schema: JSONSchema4 | JSONSchema4[];
        deprecated?: boolean;
        replacedBy?: [];
        type: "problem" | "suggestion" | "layout";
    }
}

declare module 'eslint-plugin-jsonc/meta' {
    export const name: "eslint-plugin-jsonc";
    export const version: "2.14.0";
}

